// INTRO
bool intro_bClickA;
bool intro_bClickD;

u16* intro_bg0 = (u16*)0x6000000;
u16* intro_bg1 = (u16*)0x6002800;
u16* intro_bg2 = (u16*)0x6007000;
int intro_warp = 0;
int intro_stars = 0;
int intro_fade = 0;
u8 intro_state = 0;

u8 intro_cpos = 0;
u16 intro_cpoz[] = {0x4D47, 0x5B47, 0x6847};

void Intro(void)
{
	
	REG_BLDMOD = 0x3FBF;
	REG_COLY = 16;
	intro_fade = 16<<8;
	intro_state = 0;
	intro_bClickA = true;
	intro_bClickD = true;
	ClearSprites();
	CopyOAM();
	REG_DISPCNT = MODE_0 | BG0_ENABLE | BG1_ENABLE | BG2_ENABLE | OBJ_ENABLE | OBJ_MAP_2D;
	
	REG_BG0CNT = 0x3;
	REG_BG1CNT = 0x503;
	REG_BG2CNT = 0xE02;
	REG_BG2HOFS = 256 - 40;
	REG_BG2VOFS = 256 - 16;
	
	copy2obj((u8*)gfx_warp, (u16*)0x6000800, 64, 64, false);
	copy2obj((u8*)gfx_stars, (u16*)0x6000900, 64, 64, false);
	copy2obj((u8*)gfx_eKidP, (u16*)0x6003000, 160, 128, true);
	
	int x, y;
	for (x = 0; x < 32; x++)
		for (y = 0; y < 32; y++)
			intro_bg0[x + y * 32] = 64 + (x % 8) + (y % 8) * 32;
	for (x = 0; x < 32; x++)
		for (y = 0; y < 32; y++)
			intro_bg1[x + y * 32] = 72 + (x % 8) + (y % 8) * 32;
	for (x = 0; x < 32; x++)
		for (y = 0; y < 32; y++)
			intro_bg2[x + y * 32] = 404;
	while (1)
	{
		
		if (intro_state == 0)
		{
			if (intro_fade > 0)
			{
				intro_fade -= 128;
				if (intro_fade <= 0)
				{
					intro_fade = 0;
					intro_state = 1;
					REG_BLDMOD = 0x0;
					REG_COLY = 0;
					intro_fade = 0;
					
					REG_DISPCNT |= BG1_ENABLE;
					goto skipp1;
				}
				if (REG_COLY != intro_fade>>8)
				{
					
					REG_COLY = intro_fade >> 8;
				}
				
			}
		}
skipp1:
		if (intro_state == 1)
		{
			intro_fade++;
			if (intro_fade >= 60)
			{
				intro_fade = 0;
				intro_state++;
			}
			
		}
		if (intro_state >= 2 && intro_state <= 11)
		{
			for (y = 0; y < 16; y++)
			{
				intro_bg2[9 - (intro_state - 2) + y * 32] = 384 + (9 - (intro_state - 2) + y * 32);
				intro_bg2[10 + (intro_state - 2) + y * 32] = 384 + (10 + (intro_state - 2) + y * 32);
			}
			intro_state++;
			if (intro_state == 12)
			{
				intro_fade = 0;
				goto skipp2;
			}
			/*
			intro_fade += 256;
			if (intro_fade >= 1<<8)
			{
				intro_fade = 0;
				intro_state++;
				if (intro_state == 12)
				{
					intro_fade = 0;
					goto skipp2;
				}
			}
			if (intro_fade <= 256)
			{
				
			}
			*/
			
		}
skipp2:
		if (intro_state >= 12 && intro_state <= 19)
		{
			for (y = 0; y < 8; y++)
			{
				copy2obj((u8*)gfx_blank, (u16*)(0x60008E0 - (intro_state - 12) * 32 + y * 1024), 8, 8, false);
				copy2obj((u8*)gfx_blank, (u16*)(0x60009E0 - (intro_state - 12) * 32 + y * 1024), 8, 8, false);
				//copy2obj((u8*)gfx_blank, (u16*)(0x6000800 + (intro_state - 12) * 32 + y * 1024), 8, 8, false);
				//copy2obj((u8*)gfx_blank, (u16*)(0x6000900 + (intro_state - 12) * 32 + y * 1024), 8, 8, false);
			}
			intro_state++;
			if (intro_state == 20)
			{
				intro_fade = 100;
				goto skipp3;
			}
			/*
			intro_fade += 256;
			if (intro_fade >= 1<<8)
			{
				intro_fade = 0;
				intro_state++;
				if (intro_state == 20)
				{
					intro_fade = 1000;
					goto skipp3;
				}
			}
			//copy2obj((u8*)gfx_blank, (u16*)0x6000800, 8, 8, false);
			
			if (intro_fade <= 256)
			{
				
			}
			*/
			
		}
skipp3:
		
		if (intro_state == 20)
		{
			intro_fade--;
			if (intro_fade <= 0)
			{
				intro_state++;
				intro_fade = 0;
			}
		}
		
		if (intro_state >= 21 && intro_state <= 30)
		{
			for (y = 0; y < 16; y++)
			{
				intro_bg2[9 - (intro_state - 21) + y * 32] = 801;
				intro_bg2[10 + (intro_state - 21) + y * 32] = 801;
			}
			intro_state++;
			if (intro_state == 31)
			{
				copy2obj((u8*)gfx_title, (u16*)0x6003000, 160, 128, true);
				goto skipp4;
			}
			/*
			intro_fade += 256;
			if (intro_fade >= 1<<8)
			{
				intro_fade = 0;
				intro_state++;
				if (intro_state == 31)
				{
					copy2obj((u8*)gfx_title, (u16*)0x6003000, 160, 256, true);
					goto skipp4;
				}
			}
			if (intro_fade <= 256)
			{
				for (y = 0; y < 16; y++)
				{
					intro_bg2[9 - (intro_state - 21) + y * 32] = 833;
					intro_bg2[10 + (intro_state - 21) + y * 32] = 833;
				}
			}
			*/
		}
skipp4:
		if (intro_state == 31)
		{
			intro_fade++;
			if (intro_fade >= 60)
			{
				intro_fade = 0;
				intro_state++;
				LoadGame();
			}
		}
		if (intro_state >= 32 && intro_state <= 39)
		{
			for (x = 0; x < 20; x++)
			{
				intro_bg2[x + ((intro_state - 32) * 32)] = 384 + x + ((intro_state - 32)) * 32;
				intro_bg2[x + ((15 - (intro_state - 32)) * 32)] = 384 + x + (15 - (intro_state - 32)) * 32;
			}
			intro_state++;
			if (intro_state == 40)
			{
				copy2obj((u8*)gfx_point, (u16*)0x6010020, 8, 8, true);
				AddSprite_8x8((intro_cpoz[intro_cpos] & 0xFF) + 40, (intro_cpoz[intro_cpos] >> 8) + 16, 1);
				goto skipp5;
			}
			/*
			intro_fade += 256;
			if (intro_fade >= 1<<8)
			{
				intro_fade = 0;
				intro_state++;
				if (intro_state == 40)
				{
					copy2obj((u8*)gfx_point, (u16*)0x60032a0, 8, 8, false);
					AddSprite_8x8(intro_cpoz[intro_cpos] & 0xFF, intro_cpoz[intro_cpos] >> 8, 404);
					goto skipp5;
				}
			}
			if (intro_fade <= 256)
			{
				for (x = 0; x < 20; x++)
				{
					intro_bg2[x + ((intro_state - 32) * 32)] = 384 + x + ((intro_state - 32)) * 32;
					intro_bg2[x + ((15 - (intro_state - 32)) * 32)] = 384 + x + (15 - (intro_state - 32)) * 32;
				}
			}
			*/
		}
skipp5:
		if (intro_state == 40)
		{
			Intro_getinput();
		}
		if (intro_state <= 19)
		{
			intro_warp+=1000;
			if (intro_warp >= 64<<8) intro_warp -= 64<<8;
			REG_BG0HOFS = intro_warp>>8;
			intro_stars+=320;
			if (intro_stars >= 64<<8) intro_stars -= 64<<8;
			REG_BG1HOFS = intro_stars>>8;
		}
		CopyOAM();
		WaitForVSync();
	}
}

void Intro_getinput(void)
{
	if (KeyState(KEY_DOWN) && !intro_bClickD)
	{
		intro_bClickD = true;
		if (intro_cpos < 2)
		{
			Snd_Stop();
			Snd_Beep(3, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			intro_cpos++;
			sprites[0].attribute0 = (intro_cpoz[intro_cpos] >> 8) + 16;
			sprites[0].attribute1 = (intro_cpoz[intro_cpos] & 0xFF) + 40;
		}
	}
	else if (KeyState(KEY_UP) && !intro_bClickD)
	{
		intro_bClickD = true;
		if (intro_cpos > 0)
		{
			Snd_Stop();
			Snd_Beep(3, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			intro_cpos--;
			sprites[0].attribute0 = (intro_cpoz[intro_cpos] >> 8) + 16;
			sprites[0].attribute1 = (intro_cpoz[intro_cpos] & 0xFF) + 40;
		}
	}
	if (KeyState(KEY_A) && !intro_bClickA)
	{
		intro_bClickA = true;
		if (intro_cpos == 0)
		{
			Snd_Stop();
			//Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			//Snd_Beep(6, 0, 5, 2, 2, 6, 0, 0xF, 0x6E0);
			Snd_Beep(7, 0, 7, 7, 2, 6, 0, 0xF, 0x6E0);
			Start_Game();
			Highscore_Show();
			copy2obj((u8*)gfx_title, (u16*)0x6003000, 160, 128, true);
			AddSprite_8x8((intro_cpoz[intro_cpos] & 0xFF) + 40, (intro_cpoz[intro_cpos] >> 8) + 16, 1);
		}
		else if (intro_cpos == 1)
		{
			Snd_Stop();
			Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			Highscore_Show();
			copy2obj((u8*)gfx_title, (u16*)0x6003000, 160, 128, true);
			AddSprite_8x8((intro_cpoz[intro_cpos] & 0xFF) + 40, (intro_cpoz[intro_cpos] >> 8) + 16, 1);
		}
		else if (intro_cpos == 2)
		{
			Snd_Stop();
			Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			Options_Show();
			copy2obj((u8*)gfx_title, (u16*)0x6003000, 160, 128, true);
			AddSprite_8x8((intro_cpoz[intro_cpos] & 0xFF) + 40, (intro_cpoz[intro_cpos] >> 8) + 16, 1);
		}
	}
	if (!(KeyState(KEY_UP)) && !(KeyState(KEY_DOWN))) intro_bClickD = false;
	if (!(KeyState(KEY_A))) intro_bClickA = false;
}
