
typedef struct HighScore
{
	char Name[16];
	u32 Score;
} HighScore;

struct HighScore scores[5];

bool Check_HighScore(u32 score)
{
	int loop;
	for (loop = 0; loop < 5; loop++)
	{
		if (score > scores[loop].Score) return true;
	}
	return false;
}

void Add_HighScore(char* Name, u32 score)
{
	int loop;
	int loop2;
	int entry = 0;
	
	for (loop = 0; loop < 5; loop++)
	{
		if (score > scores[loop].Score)
		{
			entry = loop;
			break;
		}
	}
	for (loop = 4; loop >= entry; loop--)
	{
		if (!loop == 0)
		{
			for (loop2 = 0; loop2 < 16; loop2++)
			{
				scores[loop].Name[loop2] = scores[loop-1].Name[loop2];
			}
			scores[loop].Score = scores[loop-1].Score;
		}
	}
	for (loop = 0; loop < 16; loop++)
	{
		if (!Name[loop] == 0)
		{
			scores[entry].Name[loop] = Name[loop];
		}
		else
		{
			scores[entry].Name[loop] = 0;
			break;
		}
	}
	scores[entry].Score = score;
	Save_Scores();
}

void Reset_Scores(void)
{
	
	scores[0].Name[0] = 'e';
	scores[0].Name[1] = 'K';
	scores[0].Name[2] = 'i';
	scores[0].Name[3] = 'd';
	scores[0].Name[4] = 0;
	
	scores[0].Score = 20000;
	scores[1].Score = 12000;
	scores[2].Score = 8000;
	scores[3].Score = 4625;
	scores[4].Score = 2500;
	
	u32 loop;
	u32 loop2;
	int name_index;
	int used_index[5] = {-1, -1, -1, -1, -1};
	for (loop = 1; loop < 5; loop++)
	{
regetname:
		name_index = rand() % max_names;
		for (loop2 = 0; loop2 < 5; loop2++)
		{
			if (name_index == used_index[loop2])
				goto regetname;
		}
		used_index[loop] = name_index;
		for (loop2 = 0; loop2 < 16; loop2++)
		{
			if (loop2 < 12)
				scores[loop].Name[loop2] = name_list[loop2 + name_index * 12];
			else
				scores[loop].Name[loop2] = 0;
		}
	}
	
}

void Save_Scores(void)
{
	u32 loop;
	u32 loop2;
	for (loop = 0; loop < 5; loop++)
	{
		for (loop2 = 0; loop2 < 16; loop2++)
		{
			SRAM[16 + loop * 16 + loop2] = scores[loop].Name[loop2];
		}
	}
	for (loop = 0; loop < 5; loop++)
	{
		SRAM[96 + loop * 4] = scores[loop].Score & 0xFF;
		SRAM[97 + loop * 4] = (scores[loop].Score >> 8) & 0xFF;
		SRAM[98 + loop * 4] = (scores[loop].Score >> 16) & 0xFF;
		SRAM[99 + loop * 4] = (scores[loop].Score >> 24);
	}
}

void Load_Scores(void)
{
	u32 loop;
	u32 loop2;
	for (loop = 0; loop < 5; loop++)
	{
		for (loop2 = 0; loop2 < 16; loop2++)
		{
			scores[loop].Name[loop2] = SRAM[16 + loop * 16 + loop2];
		}
	}
	for (loop = 0; loop < 5; loop++)
	{
		scores[loop].Score = SRAM[96 + loop * 4] + SRAM[97 + loop * 4] * 256 + SRAM[98 + loop * 4] * 65536 + SRAM[99 + loop * 4] * 16777216;
	}
}
