// Greatest Snakes Screen

// Vertical positions for hte captions
u8 hs_Voffset[] = {25, 39, 52, 65, 78};
// Positions for the cursor to goto
u8 hs_Voffset_cur[] = {98, 112};
u8 hs_curpos;

// Key click variables, stops rapid fire
bool hs_bClickAB;
bool hs_bClickD;

// Tells it to exit
bool hs_exit;

void Highscore_Show(void)
{
	// Clear the sprites
	ClearSprites();
	CopyOAM();
	// Copy the graphics to VRAM
	copy2obj((u8*)gfx_greatsnake, (u16*)0x6003000, 160, 128, true);
	copy2obj((u8*)gfx_font, (u16*)0x6010400, 256, 64, false);
	// Set the cursor position
	hs_curpos = 1;
	// Add the cursor sprite
	AddSprite_8x8(110 + 40, hs_Voffset_cur[hs_curpos] + 16, 1);
	// Setting variables
	hs_bClickAB = true;
	hs_bClickD = true;
	hs_exit = false;
	hs_Redraw();
	while (1)
	{
		// Main loop for the highscore screen
		hs_getinput(); // get input
		CopyOAM(); // copy oam
		WaitForVSync(); // wait for VSync
		
		if (hs_exit)
		{
			break;
		}
	}
	ClearSprites();
	CopyOAM();
}

void hs_getinput(void)
{
	if (!hs_bClickD)
	{
		if (KeyState(KEY_UP))
		{
			hs_bClickD = true;
			if (hs_curpos == 1)
			{
				hs_curpos = 0;
				cur_sprite = 0;
				AddSprite_8x8(110 + 40, hs_Voffset_cur[hs_curpos] + 16, 1);
				Snd_Stop();
				Snd_Beep(3, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			}
		}
		else if (KeyState(KEY_DOWN))
		{
			hs_bClickD = true;
			if (hs_curpos == 0)
			{
				hs_curpos = 1;
				cur_sprite = 0;
				AddSprite_8x8(110 + 40, hs_Voffset_cur[hs_curpos] + 16, 1);
				Snd_Stop();
				Snd_Beep(3, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			}
		}
	}
	if (!hs_bClickAB)
	{
		if (KeyState(KEY_A))
		{
			hs_bClickAB = true;
			if (hs_curpos == 0)
			{
				Snd_Stop();
				Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
				Reset_Scores();
				Save_Scores();
				ClearSprites();
				AddSprite_8x8(110 + 40, hs_Voffset_cur[hs_curpos] + 16, 1);
				hs_Redraw();

			}
			else if (hs_curpos == 1)
			{
				hs_exit = true;
				Snd_Stop();
				Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			}
		}
		else if (KeyState(KEY_B))
		{
			hs_exit = true;
			Snd_Stop();
			Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
		}
	}
	if (!KeyState(KEY_UP) && !KeyState(KEY_DOWN)) hs_bClickD = false;
	if (!KeyState(KEY_A) && !KeyState(KEY_B)) hs_bClickAB = false;
}

void hs_Redraw(void)
{
	hs_DrawString(20 + 40, hs_Voffset[0] + 16, scores[0].Name, false);
	hs_DrawString(20 + 40, hs_Voffset[1] + 16, scores[1].Name, false);
	hs_DrawString(20 + 40, hs_Voffset[2] + 16, scores[2].Name, false);
	hs_DrawString(20 + 40, hs_Voffset[3] + 16, scores[3].Name, false);
	hs_DrawString(20 + 40, hs_Voffset[4] + 16, scores[4].Name, false);
	char str_Scores[8];
	u32 loop;
	for (loop = 0; loop < 5; loop++)
	{
		str_Scores[7] = 0;
		str_Scores[6] = 48+(scores[loop].Score % 10);
		str_Scores[5] = 48+(scores[loop].Score % 100) / 10;
		str_Scores[4] = 48+(scores[loop].Score % 1000) / 100;
		str_Scores[3] = 48+(scores[loop].Score % 10000) / 1000;
		str_Scores[2] = 48+(scores[loop].Score % 100000) / 10000;
		str_Scores[1] = 48+(scores[loop].Score % 1000000) / 100000;
		str_Scores[0] = 48+(scores[loop].Score % 10000000) / 1000000;
		hs_DrawString(106 + 40, hs_Voffset[loop] + 16, str_Scores, true);
	}
}

int hs_DrawString(int x, int y, char* str, bool rmzero)
{
	bool bSkip0 = true;;
	u32 loop;
	int dpos;
	u16 c;
	dpos = x;
	for (loop = 0; loop < 12; loop++)
	{

		if (str[loop] == 0)
		{
			return dpos - x;
		}
		else if (str[loop] == 32)
		{
			dpos += 3;
			goto skipadd;
		}
		else if (str[loop] >= 48 && str[loop] <= 57)
		{
			if (rmzero && str[loop] == 48 && bSkip0) goto skipadd;
			bSkip0 = false;
			c = 32 + ((str[loop] - 48) * 2);
			AddSprite_16x16(dpos, y, c);
		}
		else if (str[loop] >= 65 && str[loop] <= 70)
		{
			c = 52 + ((str[loop] - 65) * 2);
			AddSprite_16x16(dpos, y, c);
		}
		else if (str[loop] >= 71 && str[loop] <= 86)
		{
			c = 96 + ((str[loop] - 71) * 2);
			AddSprite_16x16(dpos, y, c);
		}
		else if (str[loop] >= 87 && str[loop] <= 90)
		{
			c = 160 + ((str[loop] - 87) * 2);
			AddSprite_16x16(dpos, y, c);
		}
		else if (str[loop] >= 97 && str[loop] <= 108)
		{
			c = 168 + ((str[loop] - 97) * 2);
			AddSprite_16x16(dpos, y, c);
		}
		else if (str[loop] >= 109 && str[loop] <= 122)
		{
			c = 224 + ((str[loop] - 109) * 2);
			AddSprite_16x16(dpos, y, c);
		}
		else
		{
			goto skipadd;
		}

		if (str[loop] >= 48 && str[loop] <= 57)
		{
			dpos += font_sizes[str[loop] - 48];
		}
		else if (str[loop] >= 65 && str[loop] <= 90)
		{
			dpos += font_sizes[10 + (str[loop] - 65)];
		}
		else if (str[loop] >= 97 && str[loop] <= 122)
		{
			dpos += font_sizes[36 + (str[loop] - 97)];
		}
		
skipadd:;
	}
	return dpos - x;
}
